<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUPC_Inventory_Response ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUPC_Inventory_Response
 * @subpackage Arrays
 */
class ArrayOfUPC_Inventory_Response extends AbstractStructArrayBase
{
    /**
     * The UPC_Inventory_Response
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UPC_Inventory_Response[]
     */
    public $UPC_Inventory_Response;
    /**
     * Constructor method for ArrayOfUPC_Inventory_Response
     * @uses ArrayOfUPC_Inventory_Response::setUPC_Inventory_Response()
     * @param \StructType\UPC_Inventory_Response[] $uPC_Inventory_Response
     */
    public function __construct(array $uPC_Inventory_Response = array())
    {
        $this
            ->setUPC_Inventory_Response($uPC_Inventory_Response);
    }
    /**
     * Get UPC_Inventory_Response value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UPC_Inventory_Response[]|null
     */
    public function getUPC_Inventory_Response()
    {
        return isset($this->UPC_Inventory_Response) ? $this->UPC_Inventory_Response : null;
    }
    /**
     * Set UPC_Inventory_Response value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UPC_Inventory_Response[] $uPC_Inventory_Response
     * @return \ArrayType\ArrayOfUPC_Inventory_Response
     */
    public function setUPC_Inventory_Response(array $uPC_Inventory_Response = array())
    {
        foreach ($uPC_Inventory_Response as $arrayOfUPC_Inventory_ResponseUPC_Inventory_ResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfUPC_Inventory_ResponseUPC_Inventory_ResponseItem instanceof \StructType\UPC_Inventory_Response) {
                throw new \InvalidArgumentException(sprintf('The UPC_Inventory_Response property can only contain items of \StructType\UPC_Inventory_Response, "%s" given', is_object($arrayOfUPC_Inventory_ResponseUPC_Inventory_ResponseItem) ? get_class($arrayOfUPC_Inventory_ResponseUPC_Inventory_ResponseItem) : gettype($arrayOfUPC_Inventory_ResponseUPC_Inventory_ResponseItem)), __LINE__);
            }
        }
        if (is_null($uPC_Inventory_Response) || (is_array($uPC_Inventory_Response) && empty($uPC_Inventory_Response))) {
            unset($this->UPC_Inventory_Response);
        } else {
            $this->UPC_Inventory_Response = $uPC_Inventory_Response;
        }
        return $this;
    }
    /**
     * Add item to UPC_Inventory_Response value
     * @throws \InvalidArgumentException
     * @param \StructType\UPC_Inventory_Response $item
     * @return \ArrayType\ArrayOfUPC_Inventory_Response
     */
    public function addToUPC_Inventory_Response(\StructType\UPC_Inventory_Response $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UPC_Inventory_Response) {
            throw new \InvalidArgumentException(sprintf('The UPC_Inventory_Response property can only contain items of \StructType\UPC_Inventory_Response, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UPC_Inventory_Response[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UPC_Inventory_Response|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UPC_Inventory_Response|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UPC_Inventory_Response|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UPC_Inventory_Response|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UPC_Inventory_Response|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UPC_Inventory_Response
     */
    public function getAttributeName()
    {
        return 'UPC_Inventory_Response';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUPC_Inventory_Response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
