<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'UserName' => '\\StructType\\UserName',
            'ArrayOfUPC_Inventory_Request' => '\\ArrayType\\ArrayOfUPC_Inventory_Request',
            'UPC_Inventory_Request' => '\\StructType\\UPC_Inventory_Request',
            'RequestResponse' => '\\StructType\\RequestResponse',
            'ArrayOfUPC_Inventory_Response' => '\\ArrayType\\ArrayOfUPC_Inventory_Response',
            'UPC_Inventory_Response' => '\\StructType\\UPC_Inventory_Response',
            'Order_Header_New' => '\\StructType\\Order_Header_New',
            'ArrayOfOrder_Detail_New' => '\\ArrayType\\ArrayOfOrder_Detail_New',
            'Order_Detail_New' => '\\StructType\\Order_Detail_New',
            'NewOrderRequestResponse' => '\\StructType\\NewOrderRequestResponse',
            'Shipment_Request' => '\\StructType\\Shipment_Request',
            'NewShipmentRequestResponse' => '\\StructType\\NewShipmentRequestResponse',
            'ArrayOfshipment_status' => '\\ArrayType\\ArrayOfshipment_status',
            'shipment_status' => '\\StructType\\Shipment_status',
            'ArrayOfshipment_cartons' => '\\ArrayType\\ArrayOfshipment_cartons',
            'shipment_cartons' => '\\StructType\\Shipment_cartons',
            'Catalog_items_request' => '\\StructType\\Catalog_items_request',
            'Catalog_items_response' => '\\StructType\\Catalog_items_response',
            'ArrayOfcatalog_item' => '\\ArrayType\\ArrayOfcatalog_item',
            'catalog_item' => '\\StructType\\Catalog_item',
            'ArrayOfLine_list_row' => '\\ArrayType\\ArrayOfLine_list_row',
            'Line_list_row' => '\\StructType\\Line_list_row',
            'purchase_Order_Header_New' => '\\StructType\\Purchase_Order_Header_New',
            'purchase_Order_receipt_request' => '\\StructType\\Purchase_Order_receipt_request',
            'Purchase_Order_Receipt_Response' => '\\StructType\\Purchase_Order_Receipt_Response',
            'ArrayOfPurchase_Order_Receipt_Item' => '\\ArrayType\\ArrayOfPurchase_Order_Receipt_Item',
            'Purchase_Order_Receipt_Item' => '\\StructType\\Purchase_Order_Receipt_Item',
            'Asn_Header_New' => '\\StructType\\Asn_Header_New',
            'ArrayOfAsn_Line' => '\\ArrayType\\ArrayOfAsn_Line',
            'Asn_Line' => '\\StructType\\Asn_Line',
            'New_Delivery_Ticket' => '\\StructType\\New_Delivery_Ticket',
            'ArrayOforder_status_request' => '\\ArrayType\\ArrayOforder_status_request',
            'order_status_request' => '\\StructType\\Order_status_request',
            'order_status_reply' => '\\StructType\\Order_status_reply',
            'ArrayOforder_status_order' => '\\ArrayType\\ArrayOforder_status_order',
            'order_status_order' => '\\StructType\\Order_status_order',
            'ArrayOforder_status_line' => '\\ArrayType\\ArrayOforder_status_line',
            'order_status_line' => '\\StructType\\Order_status_line',
            'Invoice_information' => '\\StructType\\Invoice_information',
            'ArrayOfinvoice_line' => '\\ArrayType\\ArrayOfinvoice_line',
            'invoice_line' => '\\StructType\\Invoice_line',
            'ArrayOfstore_item' => '\\ArrayType\\ArrayOfstore_item',
            'store_item' => '\\StructType\\Store_item',
            'ArrayOfstore_inventory' => '\\ArrayType\\ArrayOfstore_inventory',
            'store_inventory' => '\\StructType\\Store_inventory',
            'ArrayOfstore_item_inventory' => '\\ArrayType\\ArrayOfstore_item_inventory',
            'store_item_inventory' => '\\StructType\\Store_item_inventory',
            'rsac_options' => '\\StructType\\Rsac_options',
            'ArrayOfrsiq_options' => '\\ArrayType\\ArrayOfrsiq_options',
            'rsiq_options' => '\\StructType\\Rsiq_options',
            'RSIQRequestResponse' => '\\StructType\\RSIQRequestResponse',
            'ArrayOfStore_Allocation_Items' => '\\ArrayType\\ArrayOfStore_Allocation_Items',
            'Store_Allocation_Items' => '\\StructType\\Store_Allocation_Items',
            'ArrayOfstore_sales' => '\\ArrayType\\ArrayOfstore_sales',
            'store_sales' => '\\StructType\\Store_sales',
            'ArrayOfstore_item_sales' => '\\ArrayType\\ArrayOfstore_item_sales',
            'store_item_sales' => '\\StructType\\Store_item_sales',
            'get_inventory_on_hand' => '\\StructType\\Get_inventory_on_hand',
            'get_inventory_on_handResponse' => '\\StructType\\Get_inventory_on_handResponse',
            'new_order_entry' => '\\StructType\\New_order_entry',
            'new_order_entryResponse' => '\\StructType\\New_order_entryResponse',
            'get_shipment_information' => '\\StructType\\Get_shipment_information',
            'get_shipment_informationResponse' => '\\StructType\\Get_shipment_informationResponse',
            'get_catalog_information' => '\\StructType\\Get_catalog_information',
            'get_catalog_informationResponse' => '\\StructType\\Get_catalog_informationResponse',
            'import_line_list' => '\\StructType\\Import_line_list',
            'import_line_listResponse' => '\\StructType\\Import_line_listResponse',
            'new_purchase_order_entry' => '\\StructType\\New_purchase_order_entry',
            'new_purchase_order_entryResponse' => '\\StructType\\New_purchase_order_entryResponse',
            'get_purchase_order_receipt' => '\\StructType\\Get_purchase_order_receipt',
            'get_purchase_order_receiptResponse' => '\\StructType\\Get_purchase_order_receiptResponse',
            'new_asn_entry' => '\\StructType\\New_asn_entry',
            'new_asn_entryResponse' => '\\StructType\\New_asn_entryResponse',
            'new_delivery_ticket' => '\\StructType\\New_delivery_ticket_1',
            'new_delivery_ticketResponse' => '\\StructType\\New_delivery_ticketResponse',
            'order_status' => '\\StructType\\Order_status',
            'order_statusResponse' => '\\StructType\\Order_statusResponse',
            'import_invoice' => '\\StructType\\Import_invoice',
            'import_invoiceResponse' => '\\StructType\\Import_invoiceResponse',
            'retail_store_item_master' => '\\StructType\\Retail_store_item_master',
            'retail_store_item_masterResponse' => '\\StructType\\Retail_store_item_masterResponse',
            'retail_store_item_inventory' => '\\StructType\\Retail_store_item_inventory',
            'retail_store_item_inventoryResponse' => '\\StructType\\Retail_store_item_inventoryResponse',
            'retail_store_allocation_calculation' => '\\StructType\\Retail_store_allocation_calculation',
            'retail_store_allocation_calculationResponse' => '\\StructType\\Retail_store_allocation_calculationResponse',
            'retail_store_item_query' => '\\StructType\\Retail_store_item_query',
            'retail_store_item_queryResponse' => '\\StructType\\Retail_store_item_queryResponse',
            'retail_store_item_sales' => '\\StructType\\Retail_store_item_sales',
            'retail_store_item_salesResponse' => '\\StructType\\Retail_store_item_salesResponse',
        );
    }
}
