<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Getinventoryonhand ServiceType
 * @subpackage Services
 */
class Getinventoryonhand extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named get_inventory_on_hand
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Get_inventory_on_hand $parameters
     * @return \StructType\Get_inventory_on_handResponse|bool
     */
    public function get_inventory_on_hand(\StructType\Get_inventory_on_hand $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->get_inventory_on_hand($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Get_inventory_on_handResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
