<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Getshipmentinformation ServiceType
 * @subpackage Services
 */
class Getshipmentinformation extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named get_shipment_information
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Get_shipment_information $parameters
     * @return \StructType\Get_shipment_informationResponse|bool
     */
    public function get_shipment_information(\StructType\Get_shipment_information $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->get_shipment_information($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Get_shipment_informationResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
