<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for catalog_item StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:catalog_item
 * @subpackage Structs
 */
class Catalog_item extends AbstractStructBase
{
    /**
     * The color
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $color;
    /**
     * The color_code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $color_code;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The fabric
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $fabric;
    /**
     * The season_code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $season_code;
    /**
     * The size_code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $size_code;
    /**
     * The style
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $style;
    /**
     * The upc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $upc;
    /**
     * Constructor method for catalog_item
     * @uses Catalog_item::setColor()
     * @uses Catalog_item::setColor_code()
     * @uses Catalog_item::setDescription()
     * @uses Catalog_item::setFabric()
     * @uses Catalog_item::setSeason_code()
     * @uses Catalog_item::setSize_code()
     * @uses Catalog_item::setStyle()
     * @uses Catalog_item::setUpc()
     * @param string $color
     * @param string $color_code
     * @param string $description
     * @param string $fabric
     * @param string $season_code
     * @param string $size_code
     * @param string $style
     * @param string $upc
     */
    public function __construct($color = null, $color_code = null, $description = null, $fabric = null, $season_code = null, $size_code = null, $style = null, $upc = null)
    {
        $this
            ->setColor($color)
            ->setColor_code($color_code)
            ->setDescription($description)
            ->setFabric($fabric)
            ->setSeason_code($season_code)
            ->setSize_code($size_code)
            ->setStyle($style)
            ->setUpc($upc);
    }
    /**
     * Get color value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getColor()
    {
        return isset($this->color) ? $this->color : null;
    }
    /**
     * Set color value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $color
     * @return \StructType\Catalog_item
     */
    public function setColor($color = null)
    {
        // validation for constraint: string
        if (!is_null($color) && !is_string($color)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($color)), __LINE__);
        }
        if (is_null($color) || (is_array($color) && empty($color))) {
            unset($this->color);
        } else {
            $this->color = $color;
        }
        return $this;
    }
    /**
     * Get color_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getColor_code()
    {
        return isset($this->color_code) ? $this->color_code : null;
    }
    /**
     * Set color_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $color_code
     * @return \StructType\Catalog_item
     */
    public function setColor_code($color_code = null)
    {
        // validation for constraint: string
        if (!is_null($color_code) && !is_string($color_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($color_code)), __LINE__);
        }
        if (is_null($color_code) || (is_array($color_code) && empty($color_code))) {
            unset($this->color_code);
        } else {
            $this->color_code = $color_code;
        }
        return $this;
    }
    /**
     * Get description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : null;
    }
    /**
     * Set description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \StructType\Catalog_item
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->description);
        } else {
            $this->description = $description;
        }
        return $this;
    }
    /**
     * Get fabric value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFabric()
    {
        return isset($this->fabric) ? $this->fabric : null;
    }
    /**
     * Set fabric value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fabric
     * @return \StructType\Catalog_item
     */
    public function setFabric($fabric = null)
    {
        // validation for constraint: string
        if (!is_null($fabric) && !is_string($fabric)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fabric)), __LINE__);
        }
        if (is_null($fabric) || (is_array($fabric) && empty($fabric))) {
            unset($this->fabric);
        } else {
            $this->fabric = $fabric;
        }
        return $this;
    }
    /**
     * Get season_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSeason_code()
    {
        return isset($this->season_code) ? $this->season_code : null;
    }
    /**
     * Set season_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $season_code
     * @return \StructType\Catalog_item
     */
    public function setSeason_code($season_code = null)
    {
        // validation for constraint: string
        if (!is_null($season_code) && !is_string($season_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($season_code)), __LINE__);
        }
        if (is_null($season_code) || (is_array($season_code) && empty($season_code))) {
            unset($this->season_code);
        } else {
            $this->season_code = $season_code;
        }
        return $this;
    }
    /**
     * Get size_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSize_code()
    {
        return isset($this->size_code) ? $this->size_code : null;
    }
    /**
     * Set size_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $size_code
     * @return \StructType\Catalog_item
     */
    public function setSize_code($size_code = null)
    {
        // validation for constraint: string
        if (!is_null($size_code) && !is_string($size_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($size_code)), __LINE__);
        }
        if (is_null($size_code) || (is_array($size_code) && empty($size_code))) {
            unset($this->size_code);
        } else {
            $this->size_code = $size_code;
        }
        return $this;
    }
    /**
     * Get style value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStyle()
    {
        return isset($this->style) ? $this->style : null;
    }
    /**
     * Set style value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $style
     * @return \StructType\Catalog_item
     */
    public function setStyle($style = null)
    {
        // validation for constraint: string
        if (!is_null($style) && !is_string($style)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($style)), __LINE__);
        }
        if (is_null($style) || (is_array($style) && empty($style))) {
            unset($this->style);
        } else {
            $this->style = $style;
        }
        return $this;
    }
    /**
     * Get upc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpc()
    {
        return isset($this->upc) ? $this->upc : null;
    }
    /**
     * Set upc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upc
     * @return \StructType\Catalog_item
     */
    public function setUpc($upc = null)
    {
        // validation for constraint: string
        if (!is_null($upc) && !is_string($upc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($upc)), __LINE__);
        }
        if (is_null($upc) || (is_array($upc) && empty($upc))) {
            unset($this->upc);
        } else {
            $this->upc = $upc;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Catalog_item
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
