<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for import_line_list StructType
 * @subpackage Structs
 */
class Import_line_list extends AbstractStructBase
{
    /**
     * The user
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserName
     */
    public $user;
    /**
     * The line_list_rows
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfLine_list_row
     */
    public $line_list_rows;
    /**
     * Constructor method for import_line_list
     * @uses Import_line_list::setUser()
     * @uses Import_line_list::setLine_list_rows()
     * @param \StructType\UserName $user
     * @param \ArrayType\ArrayOfLine_list_row $line_list_rows
     */
    public function __construct(\StructType\UserName $user = null, \ArrayType\ArrayOfLine_list_row $line_list_rows = null)
    {
        $this
            ->setUser($user)
            ->setLine_list_rows($line_list_rows);
    }
    /**
     * Get user value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserName|null
     */
    public function getUser()
    {
        return isset($this->user) ? $this->user : null;
    }
    /**
     * Set user value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UserName $user
     * @return \StructType\Import_line_list
     */
    public function setUser(\StructType\UserName $user = null)
    {
        if (is_null($user) || (is_array($user) && empty($user))) {
            unset($this->user);
        } else {
            $this->user = $user;
        }
        return $this;
    }
    /**
     * Get line_list_rows value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfLine_list_row|null
     */
    public function getLine_list_rows()
    {
        return isset($this->line_list_rows) ? $this->line_list_rows : null;
    }
    /**
     * Set line_list_rows value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfLine_list_row $line_list_rows
     * @return \StructType\Import_line_list
     */
    public function setLine_list_rows(\ArrayType\ArrayOfLine_list_row $line_list_rows = null)
    {
        if (is_null($line_list_rows) || (is_array($line_list_rows) && empty($line_list_rows))) {
            unset($this->line_list_rows);
        } else {
            $this->line_list_rows = $line_list_rows;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Import_line_list
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
