<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for order_status_line StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:order_status_line
 * @subpackage Structs
 */
class Order_status_line extends AbstractStructBase
{
    /**
     * The QTY
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $QTY;
    /**
     * The QTY_processed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $QTY_processed;
    /**
     * The SKU
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SKU;
    /**
     * Constructor method for order_status_line
     * @uses Order_status_line::setQTY()
     * @uses Order_status_line::setQTY_processed()
     * @uses Order_status_line::setSKU()
     * @param float $qTY
     * @param float $qTY_processed
     * @param string $sKU
     */
    public function __construct($qTY = null, $qTY_processed = null, $sKU = null)
    {
        $this
            ->setQTY($qTY)
            ->setQTY_processed($qTY_processed)
            ->setSKU($sKU);
    }
    /**
     * Get QTY value
     * @return float|null
     */
    public function getQTY()
    {
        return $this->QTY;
    }
    /**
     * Set QTY value
     * @param float $qTY
     * @return \StructType\Order_status_line
     */
    public function setQTY($qTY = null)
    {
        $this->QTY = $qTY;
        return $this;
    }
    /**
     * Get QTY_processed value
     * @return float|null
     */
    public function getQTY_processed()
    {
        return $this->QTY_processed;
    }
    /**
     * Set QTY_processed value
     * @param float $qTY_processed
     * @return \StructType\Order_status_line
     */
    public function setQTY_processed($qTY_processed = null)
    {
        $this->QTY_processed = $qTY_processed;
        return $this;
    }
    /**
     * Get SKU value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSKU()
    {
        return isset($this->SKU) ? $this->SKU : null;
    }
    /**
     * Set SKU value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sKU
     * @return \StructType\Order_status_line
     */
    public function setSKU($sKU = null)
    {
        // validation for constraint: string
        if (!is_null($sKU) && !is_string($sKU)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sKU)), __LINE__);
        }
        if (is_null($sKU) || (is_array($sKU) && empty($sKU))) {
            unset($this->SKU);
        } else {
            $this->SKU = $sKU;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Order_status_line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
