<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for purchase_Order_Header_New StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:purchase_Order_Header_New
 * @subpackage Structs
 */
class Purchase_Order_Header_New extends AbstractStructBase
{
    /**
     * The Order_Details
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfOrder_Detail_New
     */
    public $Order_Details;
    /**
     * The currency
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $currency;
    /**
     * The pocomment
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pocomment;
    /**
     * The poref1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $poref1;
    /**
     * The poref2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $poref2;
    /**
     * The vendor
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $vendor;
    /**
     * Constructor method for purchase_Order_Header_New
     * @uses Purchase_Order_Header_New::setOrder_Details()
     * @uses Purchase_Order_Header_New::setCurrency()
     * @uses Purchase_Order_Header_New::setPocomment()
     * @uses Purchase_Order_Header_New::setPoref1()
     * @uses Purchase_Order_Header_New::setPoref2()
     * @uses Purchase_Order_Header_New::setVendor()
     * @param \ArrayType\ArrayOfOrder_Detail_New $order_Details
     * @param string $currency
     * @param string $pocomment
     * @param string $poref1
     * @param string $poref2
     * @param string $vendor
     */
    public function __construct(\ArrayType\ArrayOfOrder_Detail_New $order_Details = null, $currency = null, $pocomment = null, $poref1 = null, $poref2 = null, $vendor = null)
    {
        $this
            ->setOrder_Details($order_Details)
            ->setCurrency($currency)
            ->setPocomment($pocomment)
            ->setPoref1($poref1)
            ->setPoref2($poref2)
            ->setVendor($vendor);
    }
    /**
     * Get Order_Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfOrder_Detail_New|null
     */
    public function getOrder_Details()
    {
        return isset($this->Order_Details) ? $this->Order_Details : null;
    }
    /**
     * Set Order_Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfOrder_Detail_New $order_Details
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setOrder_Details(\ArrayType\ArrayOfOrder_Detail_New $order_Details = null)
    {
        if (is_null($order_Details) || (is_array($order_Details) && empty($order_Details))) {
            unset($this->Order_Details);
        } else {
            $this->Order_Details = $order_Details;
        }
        return $this;
    }
    /**
     * Get currency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrency()
    {
        return isset($this->currency) ? $this->currency : null;
    }
    /**
     * Set currency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currency
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($currency)), __LINE__);
        }
        if (is_null($currency) || (is_array($currency) && empty($currency))) {
            unset($this->currency);
        } else {
            $this->currency = $currency;
        }
        return $this;
    }
    /**
     * Get pocomment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPocomment()
    {
        return isset($this->pocomment) ? $this->pocomment : null;
    }
    /**
     * Set pocomment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pocomment
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setPocomment($pocomment = null)
    {
        // validation for constraint: string
        if (!is_null($pocomment) && !is_string($pocomment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pocomment)), __LINE__);
        }
        if (is_null($pocomment) || (is_array($pocomment) && empty($pocomment))) {
            unset($this->pocomment);
        } else {
            $this->pocomment = $pocomment;
        }
        return $this;
    }
    /**
     * Get poref1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPoref1()
    {
        return isset($this->poref1) ? $this->poref1 : null;
    }
    /**
     * Set poref1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $poref1
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setPoref1($poref1 = null)
    {
        // validation for constraint: string
        if (!is_null($poref1) && !is_string($poref1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($poref1)), __LINE__);
        }
        if (is_null($poref1) || (is_array($poref1) && empty($poref1))) {
            unset($this->poref1);
        } else {
            $this->poref1 = $poref1;
        }
        return $this;
    }
    /**
     * Get poref2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPoref2()
    {
        return isset($this->poref2) ? $this->poref2 : null;
    }
    /**
     * Set poref2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $poref2
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setPoref2($poref2 = null)
    {
        // validation for constraint: string
        if (!is_null($poref2) && !is_string($poref2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($poref2)), __LINE__);
        }
        if (is_null($poref2) || (is_array($poref2) && empty($poref2))) {
            unset($this->poref2);
        } else {
            $this->poref2 = $poref2;
        }
        return $this;
    }
    /**
     * Get vendor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVendor()
    {
        return isset($this->vendor) ? $this->vendor : null;
    }
    /**
     * Set vendor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vendor
     * @return \StructType\Purchase_Order_Header_New
     */
    public function setVendor($vendor = null)
    {
        // validation for constraint: string
        if (!is_null($vendor) && !is_string($vendor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vendor)), __LINE__);
        }
        if (is_null($vendor) || (is_array($vendor) && empty($vendor))) {
            unset($this->vendor);
        } else {
            $this->vendor = $vendor;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Purchase_Order_Header_New
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
