<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for purchase_Order_receipt_request StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:purchase_Order_receipt_request
 * @subpackage Structs
 */
class Purchase_Order_receipt_request extends AbstractStructBase
{
    /**
     * The entry_date_from
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $entry_date_from;
    /**
     * The entry_date_to
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $entry_date_to;
    /**
     * The po_ref1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $po_ref1;
    /**
     * The po_ref2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $po_ref2;
    /**
     * The po_xact
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $po_xact;
    /**
     * Constructor method for purchase_Order_receipt_request
     * @uses Purchase_Order_receipt_request::setEntry_date_from()
     * @uses Purchase_Order_receipt_request::setEntry_date_to()
     * @uses Purchase_Order_receipt_request::setPo_ref1()
     * @uses Purchase_Order_receipt_request::setPo_ref2()
     * @uses Purchase_Order_receipt_request::setPo_xact()
     * @param string $entry_date_from
     * @param string $entry_date_to
     * @param string $po_ref1
     * @param string $po_ref2
     * @param int $po_xact
     */
    public function __construct($entry_date_from = null, $entry_date_to = null, $po_ref1 = null, $po_ref2 = null, $po_xact = null)
    {
        $this
            ->setEntry_date_from($entry_date_from)
            ->setEntry_date_to($entry_date_to)
            ->setPo_ref1($po_ref1)
            ->setPo_ref2($po_ref2)
            ->setPo_xact($po_xact);
    }
    /**
     * Get entry_date_from value
     * @return string|null
     */
    public function getEntry_date_from()
    {
        return $this->entry_date_from;
    }
    /**
     * Set entry_date_from value
     * @param string $entry_date_from
     * @return \StructType\Purchase_Order_receipt_request
     */
    public function setEntry_date_from($entry_date_from = null)
    {
        // validation for constraint: string
        if (!is_null($entry_date_from) && !is_string($entry_date_from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($entry_date_from)), __LINE__);
        }
        $this->entry_date_from = $entry_date_from;
        return $this;
    }
    /**
     * Get entry_date_to value
     * @return string|null
     */
    public function getEntry_date_to()
    {
        return $this->entry_date_to;
    }
    /**
     * Set entry_date_to value
     * @param string $entry_date_to
     * @return \StructType\Purchase_Order_receipt_request
     */
    public function setEntry_date_to($entry_date_to = null)
    {
        // validation for constraint: string
        if (!is_null($entry_date_to) && !is_string($entry_date_to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($entry_date_to)), __LINE__);
        }
        $this->entry_date_to = $entry_date_to;
        return $this;
    }
    /**
     * Get po_ref1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPo_ref1()
    {
        return isset($this->po_ref1) ? $this->po_ref1 : null;
    }
    /**
     * Set po_ref1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $po_ref1
     * @return \StructType\Purchase_Order_receipt_request
     */
    public function setPo_ref1($po_ref1 = null)
    {
        // validation for constraint: string
        if (!is_null($po_ref1) && !is_string($po_ref1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($po_ref1)), __LINE__);
        }
        if (is_null($po_ref1) || (is_array($po_ref1) && empty($po_ref1))) {
            unset($this->po_ref1);
        } else {
            $this->po_ref1 = $po_ref1;
        }
        return $this;
    }
    /**
     * Get po_ref2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPo_ref2()
    {
        return isset($this->po_ref2) ? $this->po_ref2 : null;
    }
    /**
     * Set po_ref2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $po_ref2
     * @return \StructType\Purchase_Order_receipt_request
     */
    public function setPo_ref2($po_ref2 = null)
    {
        // validation for constraint: string
        if (!is_null($po_ref2) && !is_string($po_ref2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($po_ref2)), __LINE__);
        }
        if (is_null($po_ref2) || (is_array($po_ref2) && empty($po_ref2))) {
            unset($this->po_ref2);
        } else {
            $this->po_ref2 = $po_ref2;
        }
        return $this;
    }
    /**
     * Get po_xact value
     * @return int|null
     */
    public function getPo_xact()
    {
        return $this->po_xact;
    }
    /**
     * Set po_xact value
     * @param int $po_xact
     * @return \StructType\Purchase_Order_receipt_request
     */
    public function setPo_xact($po_xact = null)
    {
        // validation for constraint: int
        if (!is_null($po_xact) && !is_numeric($po_xact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($po_xact)), __LINE__);
        }
        $this->po_xact = $po_xact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Purchase_Order_receipt_request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
