<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rsac_options StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:rsac_options
 * @subpackage Structs
 */
class Rsac_options extends AbstractStructBase
{
    /**
     * The SKUs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $SKUs;
    /**
     * The flags
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $flags;
    /**
     * The groups
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $groups;
    /**
     * The stores
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $stores;
    /**
     * The warehouses
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $warehouses;
    /**
     * Constructor method for rsac_options
     * @uses Rsac_options::setSKUs()
     * @uses Rsac_options::setFlags()
     * @uses Rsac_options::setGroups()
     * @uses Rsac_options::setStores()
     * @uses Rsac_options::setWarehouses()
     * @param \ArrayType\ArrayOfstring $sKUs
     * @param \ArrayType\ArrayOfstring $flags
     * @param \ArrayType\ArrayOfstring $groups
     * @param \ArrayType\ArrayOfstring $stores
     * @param \ArrayType\ArrayOfstring $warehouses
     */
    public function __construct(\ArrayType\ArrayOfstring $sKUs = null, \ArrayType\ArrayOfstring $flags = null, \ArrayType\ArrayOfstring $groups = null, \ArrayType\ArrayOfstring $stores = null, \ArrayType\ArrayOfstring $warehouses = null)
    {
        $this
            ->setSKUs($sKUs)
            ->setFlags($flags)
            ->setGroups($groups)
            ->setStores($stores)
            ->setWarehouses($warehouses);
    }
    /**
     * Get SKUs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getSKUs()
    {
        return isset($this->SKUs) ? $this->SKUs : null;
    }
    /**
     * Set SKUs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $sKUs
     * @return \StructType\Rsac_options
     */
    public function setSKUs(\ArrayType\ArrayOfstring $sKUs = null)
    {
        if (is_null($sKUs) || (is_array($sKUs) && empty($sKUs))) {
            unset($this->SKUs);
        } else {
            $this->SKUs = $sKUs;
        }
        return $this;
    }
    /**
     * Get flags value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getFlags()
    {
        return isset($this->flags) ? $this->flags : null;
    }
    /**
     * Set flags value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $flags
     * @return \StructType\Rsac_options
     */
    public function setFlags(\ArrayType\ArrayOfstring $flags = null)
    {
        if (is_null($flags) || (is_array($flags) && empty($flags))) {
            unset($this->flags);
        } else {
            $this->flags = $flags;
        }
        return $this;
    }
    /**
     * Get groups value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getGroups()
    {
        return isset($this->groups) ? $this->groups : null;
    }
    /**
     * Set groups value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $groups
     * @return \StructType\Rsac_options
     */
    public function setGroups(\ArrayType\ArrayOfstring $groups = null)
    {
        if (is_null($groups) || (is_array($groups) && empty($groups))) {
            unset($this->groups);
        } else {
            $this->groups = $groups;
        }
        return $this;
    }
    /**
     * Get stores value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getStores()
    {
        return isset($this->stores) ? $this->stores : null;
    }
    /**
     * Set stores value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $stores
     * @return \StructType\Rsac_options
     */
    public function setStores(\ArrayType\ArrayOfstring $stores = null)
    {
        if (is_null($stores) || (is_array($stores) && empty($stores))) {
            unset($this->stores);
        } else {
            $this->stores = $stores;
        }
        return $this;
    }
    /**
     * Get warehouses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getWarehouses()
    {
        return isset($this->warehouses) ? $this->warehouses : null;
    }
    /**
     * Set warehouses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $warehouses
     * @return \StructType\Rsac_options
     */
    public function setWarehouses(\ArrayType\ArrayOfstring $warehouses = null)
    {
        if (is_null($warehouses) || (is_array($warehouses) && empty($warehouses))) {
            unset($this->warehouses);
        } else {
            $this->warehouses = $warehouses;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Rsac_options
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
