<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for store_item_sales StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:store_item_sales
 * @subpackage Structs
 */
class Store_item_sales extends AbstractStructBase
{
    /**
     * The SKU
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SKU;
    /**
     * The flag
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $flag;
    /**
     * The other_units
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $other_units;
    /**
     * The return_units
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $return_units;
    /**
     * The sales_units
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $sales_units;
    /**
     * The shrinkage_units
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $shrinkage_units;
    /**
     * Constructor method for store_item_sales
     * @uses Store_item_sales::setSKU()
     * @uses Store_item_sales::setFlag()
     * @uses Store_item_sales::setOther_units()
     * @uses Store_item_sales::setReturn_units()
     * @uses Store_item_sales::setSales_units()
     * @uses Store_item_sales::setShrinkage_units()
     * @param string $sKU
     * @param string $flag
     * @param float $other_units
     * @param float $return_units
     * @param float $sales_units
     * @param float $shrinkage_units
     */
    public function __construct($sKU = null, $flag = null, $other_units = null, $return_units = null, $sales_units = null, $shrinkage_units = null)
    {
        $this
            ->setSKU($sKU)
            ->setFlag($flag)
            ->setOther_units($other_units)
            ->setReturn_units($return_units)
            ->setSales_units($sales_units)
            ->setShrinkage_units($shrinkage_units);
    }
    /**
     * Get SKU value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSKU()
    {
        return isset($this->SKU) ? $this->SKU : null;
    }
    /**
     * Set SKU value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sKU
     * @return \StructType\Store_item_sales
     */
    public function setSKU($sKU = null)
    {
        // validation for constraint: string
        if (!is_null($sKU) && !is_string($sKU)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sKU)), __LINE__);
        }
        if (is_null($sKU) || (is_array($sKU) && empty($sKU))) {
            unset($this->SKU);
        } else {
            $this->SKU = $sKU;
        }
        return $this;
    }
    /**
     * Get flag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFlag()
    {
        return isset($this->flag) ? $this->flag : null;
    }
    /**
     * Set flag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $flag
     * @return \StructType\Store_item_sales
     */
    public function setFlag($flag = null)
    {
        // validation for constraint: string
        if (!is_null($flag) && !is_string($flag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($flag)), __LINE__);
        }
        if (is_null($flag) || (is_array($flag) && empty($flag))) {
            unset($this->flag);
        } else {
            $this->flag = $flag;
        }
        return $this;
    }
    /**
     * Get other_units value
     * @return float|null
     */
    public function getOther_units()
    {
        return $this->other_units;
    }
    /**
     * Set other_units value
     * @param float $other_units
     * @return \StructType\Store_item_sales
     */
    public function setOther_units($other_units = null)
    {
        $this->other_units = $other_units;
        return $this;
    }
    /**
     * Get return_units value
     * @return float|null
     */
    public function getReturn_units()
    {
        return $this->return_units;
    }
    /**
     * Set return_units value
     * @param float $return_units
     * @return \StructType\Store_item_sales
     */
    public function setReturn_units($return_units = null)
    {
        $this->return_units = $return_units;
        return $this;
    }
    /**
     * Get sales_units value
     * @return float|null
     */
    public function getSales_units()
    {
        return $this->sales_units;
    }
    /**
     * Set sales_units value
     * @param float $sales_units
     * @return \StructType\Store_item_sales
     */
    public function setSales_units($sales_units = null)
    {
        $this->sales_units = $sales_units;
        return $this;
    }
    /**
     * Get shrinkage_units value
     * @return float|null
     */
    public function getShrinkage_units()
    {
        return $this->shrinkage_units;
    }
    /**
     * Set shrinkage_units value
     * @param float $shrinkage_units
     * @return \StructType\Store_item_sales
     */
    public function setShrinkage_units($shrinkage_units = null)
    {
        $this->shrinkage_units = $shrinkage_units;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Store_item_sales
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
