<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for store_sales StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:store_sales
 * @subpackage Structs
 */
class Store_sales extends AbstractStructBase
{
    /**
     * The flag
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $flag;
    /**
     * The items
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstore_item_sales
     */
    public $items;
    /**
     * The sale_date
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sale_date;
    /**
     * The store
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $store;
    /**
     * Constructor method for store_sales
     * @uses Store_sales::setFlag()
     * @uses Store_sales::setItems()
     * @uses Store_sales::setSale_date()
     * @uses Store_sales::setStore()
     * @param string $flag
     * @param \ArrayType\ArrayOfstore_item_sales $items
     * @param string $sale_date
     * @param string $store
     */
    public function __construct($flag = null, \ArrayType\ArrayOfstore_item_sales $items = null, $sale_date = null, $store = null)
    {
        $this
            ->setFlag($flag)
            ->setItems($items)
            ->setSale_date($sale_date)
            ->setStore($store);
    }
    /**
     * Get flag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFlag()
    {
        return isset($this->flag) ? $this->flag : null;
    }
    /**
     * Set flag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $flag
     * @return \StructType\Store_sales
     */
    public function setFlag($flag = null)
    {
        // validation for constraint: string
        if (!is_null($flag) && !is_string($flag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($flag)), __LINE__);
        }
        if (is_null($flag) || (is_array($flag) && empty($flag))) {
            unset($this->flag);
        } else {
            $this->flag = $flag;
        }
        return $this;
    }
    /**
     * Get items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstore_item_sales|null
     */
    public function getItems()
    {
        return isset($this->items) ? $this->items : null;
    }
    /**
     * Set items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstore_item_sales $items
     * @return \StructType\Store_sales
     */
    public function setItems(\ArrayType\ArrayOfstore_item_sales $items = null)
    {
        if (is_null($items) || (is_array($items) && empty($items))) {
            unset($this->items);
        } else {
            $this->items = $items;
        }
        return $this;
    }
    /**
     * Get sale_date value
     * @return string|null
     */
    public function getSale_date()
    {
        return $this->sale_date;
    }
    /**
     * Set sale_date value
     * @param string $sale_date
     * @return \StructType\Store_sales
     */
    public function setSale_date($sale_date = null)
    {
        // validation for constraint: string
        if (!is_null($sale_date) && !is_string($sale_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sale_date)), __LINE__);
        }
        $this->sale_date = $sale_date;
        return $this;
    }
    /**
     * Get store value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStore()
    {
        return isset($this->store) ? $this->store : null;
    }
    /**
     * Set store value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $store
     * @return \StructType\Store_sales
     */
    public function setStore($store = null)
    {
        // validation for constraint: string
        if (!is_null($store) && !is_string($store)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($store)), __LINE__);
        }
        if (is_null($store) || (is_array($store) && empty($store))) {
            unset($this->store);
        } else {
            $this->store = $store;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Store_sales
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
