<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserName StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:UserName
 * @subpackage Structs
 */
class UserName extends AbstractStructBase
{
    /**
     * The user_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $user_name;
    /**
     * The user_password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $user_password;
    /**
     * Constructor method for UserName
     * @uses UserName::setUser_name()
     * @uses UserName::setUser_password()
     * @param string $user_name
     * @param string $user_password
     */
    public function __construct($user_name = null, $user_password = null)
    {
        $this
            ->setUser_name($user_name)
            ->setUser_password($user_password);
    }
    /**
     * Get user_name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUser_name()
    {
        return isset($this->user_name) ? $this->user_name : null;
    }
    /**
     * Set user_name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $user_name
     * @return \StructType\UserName
     */
    public function setUser_name($user_name = null)
    {
        // validation for constraint: string
        if (!is_null($user_name) && !is_string($user_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($user_name)), __LINE__);
        }
        if (is_null($user_name) || (is_array($user_name) && empty($user_name))) {
            unset($this->user_name);
        } else {
            $this->user_name = $user_name;
        }
        return $this;
    }
    /**
     * Get user_password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUser_password()
    {
        return isset($this->user_password) ? $this->user_password : null;
    }
    /**
     * Set user_password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $user_password
     * @return \StructType\UserName
     */
    public function setUser_password($user_password = null)
    {
        // validation for constraint: string
        if (!is_null($user_password) && !is_string($user_password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($user_password)), __LINE__);
        }
        if (is_null($user_password) || (is_array($user_password) && empty($user_password))) {
            unset($this->user_password);
        } else {
            $this->user_password = $user_password;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UserName
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
